/////////////////////////////////////////////////////////////////////////////
//
// Copyright(C) 1999-2003 Mitsuhiro Shirai
// E-mail shirai@as.email.ne.jp
//
// Last update	1999.7.13
// Last update  2003.07.14    AKKzǗpɃJX^}CY
//
// XString.h	CString̊gNX̃wb_
//
//////////////////////////////////////////////////////////////////////////////

/*

	gꂽ@\

	RXgN^		e퐔l^ɂRXgNVǉ

	rightJustify		w茅Aw蕶ŉE𖄂߂(static)
	leftJustify			w茅Aw蕶ō𖄂߂(static)
	isDigits			񂪐lǂ`FbN
	asInt				lƂĎo	(Int)
	asLong				V					(Long)
	asCommaNumStr		J}ҏW̐ƂĎo
	asNumStr			݂̂𔲂oi}CiXj

*/

#pragma once 

#include <IMM.h>

// NX`
class	XString : public CString 	{
public:
	
	// eRXgN^
	// constructs empty CString
	XString()	:CString() {};
	// copy constructor
	XString(const CString& stringSrc)	:CString(stringSrc) {};
	// from a single character
	XString(TCHAR ch, int nRepeat = 1)	:CString(ch,nRepeat) {};
	// from an ANSI string (converts to TCHAR)
	XString(LPCSTR lpsz)				:CString(lpsz) {};
	// from a UNICODE string (converts to TCHAR)
	XString(LPCWSTR lpsz)				:CString(lpsz) {};
	// subset of characters from an ANSI string (converts to TCHAR)
	XString(LPCSTR lpch, int nLength)	:CString(lpch,nLength) {};
	// subset of characters from a UNICODE string (converts to TCHAR)
	XString(LPCWSTR lpch, int nLength)	:CString(lpch,nLength) {};
	// from unsigned characters
	XString(const unsigned char* psz)	:CString(psz) {};

	// lƂRXgN^
	XString(short inNum)	:CString()	{
		int		theNum = inNum;
		char	theNumStr[13];
		itoa(theNum,theNumStr,10);
		*this = CString(theNumStr);
	};
	XString(int inNum)	:CString()	{
		int		theNum = inNum;
		char	theNumStr[13];
		itoa(theNum,theNumStr,10);
		*this = CString(theNumStr);
	};
	XString(long inNum)		:CString()	{
		long	theNum = inNum;
		char	theNumStr[13];
		ltoa(theNum,theNumStr,10);
		*this = CString(theNumStr);
	};
	XString(unsigned long inNum)	:CString()	{
		unsigned long	theNum = inNum;
		char	theNumStr[13];
		ultoa(theNum,theNumStr,10);
		*this = CString(theNumStr);
	};

	// w茅蕶񂪒ZꍇAw蕶ŉE𖄂߂
	static XString	rightJustify(CString inString,int inLen,unsigned char inChar = ' ')
		{
			CString	theStr = inString;
			int		theLen = inString.GetLength();
			if (theLen < inLen)	{
				CString	theChar(inChar);
				for (int i=0;i<(inLen - theLen);i++)	{
					theStr += theChar;
				}
			}
			return theStr;
		};

	// w茅蕶񂪒ZꍇAw蕶ō𖄂߂
	static XString	leftJustify(CString inString,int inLen,unsigned char inChar = ' ')
		{
			CString	theStr = inString;
			int		theLen = inString.GetLength();
			if (theLen < inLen)	{
				CString	theChar(inChar);
				for (int i=0;i<(inLen - theLen);i++)	{
					theStr = theChar + theStr;
				}
			}
			return theStr;
		};

	// lH(ׂĂ̕'0'`'9'A}CiX͐擪̂)
	BOOL	isDigits();

	// l
	// ̃`FbN͂ĂȂ̂ŁA
	// ȊȌꍇ͕s̒lƂȂ
	// KvɉāAisDigitsŃ`FbN
	int		asInt();
	long	asLong();

	// J}ҏW
	// ̃`FbN͂ĂȂ̂ŁA
	// ȊȌꍇ͕s̒lƂȂ
	// KvɉāAisDigitsŃ`FbN
	CString	asCommaNumStr();

	// ݂̂𔲂oi}CiXj
	// J}t̐J}̐ɂƂɗp
	// }CiXʒũ`FbN͍sĂȂ
	CString	asNumStr();

};
